if (typeof(Adressen) == "undefined") {
    var Adressen = {};
}

Adressen.adressen = {

    // prefManager : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch),

    init : function() {
        // alert("In init().");
        Adressen.mainstringbundle = document.getElementById("mainstringbundle");
        gBrowser.addEventListener("load", function() {
                // alert("In load event, testing.");
                var autoRun = Adressen.prefManager.getBoolPref("extensions.adressen.autorun");
                if (autoRun) {
                    // alert("Autorunning");
                    Adressen.adressen.run(true);
                } else {
                    // alert("Not autorunning");
                }
            }, true);
        },

    readData : function(namesToUse, dataClass) {
        var spans = content.document.getElementsByTagName("span");
        var lines = new Array();
        var cnt = 0;
        var vals = {};
        lines.push(namesToUse.join(";"));
        for (var i=0, sl=spans.length; i<sl; i++) {
            el = spans[i];
            if (el.getAttribute("class") == dataClass) {
                cnt++;
                title = el.getAttribute("title");
                fields = title.split("&");
                for (var j=0, fl=fields.length; j<fl; j++) {
                    var nameval = fields[j].split("=");
                    name = nameval[0];
                    val = nameval[1];
                    if (typeof(val) == "undefined") {
                        var msg1 = Adressen.mainstringbundle.getFormattedString("undefinedValue", [name]);
                        alert(msg1);
                        var msg2 = Adressen.mainstringbundle.getString("offendingWas");
                        msg2 = msg2 + "\n" + title;
                        alert(msg2);
                    } else {
                        val = val.replace(/\+/g, " ");
                        // val = val.replace(/;/g, "\\;");
                        val = decodeURIComponent(val);
                        val = val.replace(/"/g, "\"\"");
                        val = "\"" + val + "\"";
                        if (namesToUse.indexOf(name) != -1) {
                            vals[name] = val;
                        }
                    }
                }
                // build lines
                var ret = "";
                var thisval = "";
                for (var k=0, kl=namesToUse.length; k<kl; k++) {
                    thisval = vals[namesToUse[k]];
                    if (typeof(thisval) == "undefined") {
                        thisval = "";
                    }
                    ret += thisval + ";";
                }
                ret = ret.slice(0,-1);
                lines.push(ret);
                vals = {};
            }
        }
        if (cnt == 0) {
            return "";
        }
        var storeVal = lines.join("\r\n");
        storeVal = storeVal + "\r\n";
        return storeVal;
    },

    saveData : function(storeloc, storeVal) {
        var storefile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        storefile.initWithPath(storeloc);
        if (storefile.exists() && storefile.isDirectory()) {
            var isDir = Adressen.mainstringbundle.getString("isDir");
            alert(isDir);
            return;
        }
        if (storefile.exists() && !storefile.isWritable) {
            var notWritable = Adressen.mainstringbundle.getString("notWritable");
            alert(notWritable);
            return;
        }
        if (!storefile.exists()) {
            // @@@TODO: error handling
            storefile.create(storefile.NORMAL_FILE_TYPE, 0644);
        }
        var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        var bWord2003 = Adressen.prefManager.getBoolPref("extensions.adressen.word2003");
        if (bWord2003) {
            converter.charset = "windows-1252";
        } else {
            converter.charset = "UTF-16LE";
        }
        var rawistream = converter.convertToInputStream(storeVal);
        var istream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        istream.init(rawistream);
        ostream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        try {
            ostream.init(storefile, 0x02 | 0x10 | 0x20, 00666, 0);
        } catch(e) {
            if (Components.results.NS_ERROR_FILE_IS_LOCKED == e.result) {
                var fileLocked = Adressen.mainstringbundle.getFormattedString("fileLocked", [storeloc]);
                alert(fileLocked);
            } else {
                // unknown/unexpected error
                alert(e.message);
            }
            return;
        }
        var istreamData = "";
        var istreamBuffer = istream.readBytes(istream.available());
        while (istreamBuffer != "") {
            istreamData = istreamData + istreamBuffer;
            try {
                istreamBuffer = istream.readBytes(istream.available());
            } catch(e) {
                break;
            }
        }
        var totalLength = istreamData.length;
        ostream.write(istreamData, totalLength);
        ostream.close();
        rawistream.close();
        istream.close();
        var successMsg = Adressen.mainstringbundle.getFormattedString("successMsg", [storeloc]);
    },

    mails : function(){
        var anchors = content.document.getElementsByTagName("a");
        var bcclist = [];
        for (var i=0, al=anchors.length; i<al; i++) {
            a = anchors[i];
            href = a.getAttribute("href");
            if (href != null) {
                if (href.slice(0, 7) == "mailto:") {
                    bcclist.push(href.slice(7));
                }
            }
        }
        var bcc = bcclist.join(",");
        bcc = "bcc='" + bcc + "'";
        // just testing
        var process = Components.classes["@mozilla.org/process/util;1"]
            .createInstance(Components.interfaces.nsIProcess);
        var exefile = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsIFile);
        var tb_path = Adressen.prefManager.getCharPref("extensions.adressen.tbexe");
        if (tb_path == "") {
            var noTBexe = Adressen.mainstringbundle.getString("noTBexe");
            alert(noTBexe);
            return;
        }
        // "C:\\Program Files (x86)\\Mozilla Thunderbird\\thunderbird.exe"
        exefile.initWithPath(tb_path);
        process.init(exefile);
        var args = ["-compose", bcc];
        process.run(false, args, 2);
    },

    run : function(autorun) {
        autorun = typeof(autorun) === "undefined" ? false : autorun;
        var storeloc = "";
        var namesToUse = ["Anrede", "Position", "Vorname", "Name",
            "Firma", "Adresse1", "Ort", "Land", "Postleitzahl"];
        var storeVal = this.readData(namesToUse, "ADR_Z3988");
        var b_notfound = false;
        if (storeVal == "") {
            // no addresses found
            b_notfound = true;
            if (!autorun) {
                var nothingFound = Adressen.mainstringbundle.getString("nothingFound");
                // alert(nothingFound);
            }
        } else {
            storeloc = Adressen.prefManager.getCharPref("extensions.adressen.outputfile");
            if (storeloc == "") {
                // @@@TODO:
                // Needs some tweaking: if no location is defined,
                // use a very generic location (home dir of user
                // and file name adressen.csv) or open a save
                // as dialog. The same should happen, if the file
                // cannot be found.
                var noLocation = Adressen.mainstringbundle.getString("noLocation");
                alert(noLocation);
                return;
            }
            this.saveData(storeloc, storeVal);
        }
        //
        // and the other addresses ...
        //
        storeVal = this.readData(namesToUse, "ADR_Z3989");
        if (storeVal == "") {
            // no addresses found
            if (!autorun) {
                var nothingFound = Adressen.mainstringbundle.getString("nothingFound");
                if (b_notfound) {
                    alert(nothingFound);
                }
            }
        } else {
            storeloc = Adressen.prefManager.getCharPref("extensions.adressen.outputfile2");
            if (storeloc == "") {
                // @@@TODO:
                // Needs some tweaking: if no location is defined,
                // use a very generic location (home dir of user
                // and file name adressen.csv) or open a save
                // as dialog. The same should happen, if the file
                // cannot be found.
                var noLocation = Adressen.mainstringbundle.getString("noLocation");
                alert(noLocation);
                return;
            }
            this.saveData(storeloc, storeVal);
        }
    },
};

window.addEventListener("load", Adressen.adressen.init, false);
